﻿namespace UltraGridSummariesLoadOnDemand
{
    using System;
    using System.Data;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinDataSource;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private const int RowsCount = 1000000;
        private Random random = new Random();

        public Form1()
        {
            this.InitializeComponent();
            this.LoadDataSource(RowsCount);
            this.ultraGrid1.DisplayLayout.LoadStyle = LoadStyle.LoadOnDemand;
            this.ultraGrid1.DisplayLayout.Override.AllowRowSummaries = AllowRowSummaries.False;
        }

        private void ButtonSwitchSummaries_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Override.AllowRowSummaries = AllowRowSummaries.True;
            this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add("Total", SummaryType.Sum, this.ultraGrid1.DisplayLayout.Bands[0].Columns["Total"]);
            this.ultraGrid1.DisplayLayout.Override.SummaryDisplayArea = SummaryDisplayAreas.TopFixed;
        }

        private void ButtonLoadData_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.ultraDataSource1;
        }

        private void LoadDataSource(int rows)
        {
            DataSet dataSet = new DataSet();

            DataTable dataTable = dataSet.Tables.Add("table1");
            this.ultraDataSource1.Band.Columns.Add("id", typeof(int));
            this.ultraDataSource1.Band.Columns.Add("Name", typeof(string));
            this.ultraDataSource1.Band.Columns.Add("Total", typeof(int));
            this.ultraDataSource1.Band.Columns.Add("Date", typeof(DateTime));

            for (int row = 0; row < rows; row++)
            {
                this.ultraDataSource1.Rows.Add(new object[] { row, string.Format("Row #{0}", row), this.random.Next(1000), DateTime.Now.AddDays(row) });
            }
        }
    }
}
